/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "editor/item_view.h"

using namespace Tk::Editor;

ItemView:: ItemView(Tk::Db::Database *database, ItemTree &item_tree)
  : _database(database)
{
  set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
  item_tree.signal_entity_selected().connect( sigc::mem_fun(*this, &ItemView::load_entity) );
}

void
ItemView:: load_entity(const Tk::String &domain, const Tk::Db::Id &entity_id)
{
  Tk::Db::Ui::PropertyTable *table( new Tk::Db::Ui::PropertyTable(_database, domain, entity_id) );
  
  remove();
  add(*table);
  
  show_all();
}
