/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_NUMERICAL_TYPES_H__
#define __TK_NUMERICAL_TYPES_H__

#include <vector>

#include <gmpxx.h>

namespace Tk {
  
  typedef short SmallNumber;
  typedef std::vector<SmallNumber> SmallNumbers;
  
  typedef mpz_class Integer;
  typedef mpq_class Rational;
  typedef mpf_class Real;
  
  typedef Integer Count;
  typedef Rational Probability;
  typedef Rational Position; /***< Screen position */
  
}; /* namespace Tk */


#endif /* __TK_STRING_H__ */
