/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_PAIR_H__
#define __TK_PAIR_H__

#include <utility>

#include <stdint.h>

namespace Tk {

  typedef uint8_t PairIndex;

  template <typename T>
    class Pair : public std::pair<T, T>
    {
    public:
      Pair() {}
      Pair(const T &first, const T &second)
	: std::pair<T, T> (first, second) {}
      
      T& operator[] (PairIndex index)
	{ return index ? std::pair<T, T>::first : std::pair<T, T>::second; }
      const T& operator[] (PairIndex index) const
	{ return index ? std::pair<T, T>::first : std::pair<T, T>::second; }
      
      T& get(PairIndex index)
	{ return (*this)[index]; }
      const T& get(PairIndex index) const
	{ return (*this)[index]; }
    };

}; /* namespace Tk */


#endif /* __TK_PAIR_H__ */
