/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_HOTBITS_H__
#define __TK_HOTBITS_H__

#include <curlpp/cURLpp.hpp>

#include "randomness.h"
#include "retriever_registry.h"

namespace Tk {

  namespace Random {

    class HotBits : public Retriever
    {
    private:
      static cURLpp::Cleanup _curl;
      
      static size_t write_curl_data(Buffer *buf, char *ptr, size_t size, size_t nmemb);
      
    public:
      HotBits(unsigned chars);
      virtual Buffer * retrieve();
    };
    
    class HotBitsType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual unsigned get_preferred_block_size();
      virtual Retriever * new_retriever(unsigned count);
    };
  };
  
};


#endif /* __TK_HOTBITS_H__ */
