/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RANDOM_TYPES_H__
#define __TK_RANDOM_TYPES_H__

#include <vector>
#include <limits>
#include <string>
#include <sstream>
#include <wchar.h>

#include "libtkcommon/stream.h"

namespace Tk {
  
  namespace Random {

#ifdef ODBCXX_UNICODE
    typedef wchar_t BitChar;
#else    
    typedef char BitChar;
#endif /* ODBCXX_UNICODE */

    typedef Tk::BasicStream<BitChar> BitStream;
    typedef std::vector<BitChar> Buffer;

    static const unsigned short BITS_PER_CHAR =
      std::numeric_limits<BitChar>::digits + static_cast<unsigned>(std::numeric_limits<BitChar>::is_signed);
    
    
    class Bits : public std::vector<bool>
      {
      public:
	BitStream * get_data() const;
	size_type get_data_len() const;
	void dump_bits() const;
      };
    
  }; /* namespace Random */
  
}; /* namespace Tk */


#endif /* __TK_RANDOM_TYPES_H__ */
